import oscP5.*;
import netP5.*;
OscP5 oscP5;
NetAddress myRemoteLocation;

static final String ENGINE = P2D;
PImage img;  // Declare variable "a" of type PImage
int num = 50;
int range = 6;
float[] ax = new float[num];
float[] ay = new float[num]; 




void setup() 
{ 
  size(360, 480); // Sets window size
  frameRate(25);
  oscP5 = new OscP5(this, 5002);// start oscP5, telling it to listen for incoming messages at port 5002 */
  myRemoteLocation = new NetAddress("127.0.0.1",5002);  // set the remote location to be the localhost on port 5002
  //img = loadImage("Image_2.JPG");  // Load the image into the program    
  //img.resize(299, 474); //resizes image to x, y !!!!MUST BE ONE LESS THAN SIZE!!!
  //image(img, 0, 0);  // Displays the image at its actual size at point (0,0)
  //img.loadPixels();
  
}

void draw() 
{ 
  
  
  img = loadImage("Image_1.JPG");  // Load the image into the program    
  img.resize(358, 478); //resizes image to x, y !!!!MUST BE ONE LESS THAN SIZE!!!
  image(img, 1, 1);  // Displays the image at its actual size at point (0,0)
  img.loadPixels();
  loadPixels();
 
  
  {
    // Shift all elements 1 place to the left
    for (int i = 1; i < num; i++) {
      ax[i-1] = ax[i];
      ay[i-1] = ay[i];
    }

    // Put a new value at the end of the array
    ax[num-1] += random(-range, range);
    ay[num-1] += random(-range, range);

    // Constrain all points to the screen
    ax[num-1] = constrain(ax[num-1], 0, img.width);
    ay[num-1] = constrain(ay[num-1], 0, img.height);

    // Draw a line connecting the points
    for (int i=1; i<num; i++) {    
      float val = float(i)/num * 204.0 + 74;
      stroke(val, val);
      strokeWeight(4);  // Thicker
      line(ax[i-1], ay[i-1], ax[i], ay[i]);   
      //println((ax[i]), (ay[i]));
      //println(int((ax[i])), int(ay[i]));

      final color c = pixels[int(ay[i])*img.width + int(ax[i])];
      //println(hue(c) + "\t" + saturation(c)+ "\t" + brightness(c));
      
      OscMessage myMessage = new OscMessage("/Pixel"); // create an osc message
      myMessage.add(hue(c) + "\t" + saturation(c)+ "\t" + brightness(c)); // add an int to the osc message
      oscP5.send(myMessage, myRemoteLocation);   // send the message 

  }
    }
       }  


void mouseClicked() 
{



//final color c = pixels[mouseY*width + mouseX];
//println(hue(c) + "\t" + saturation(c)+ "\t" + brightness(c));
//setup();
//loop();
}

